# Traveling salesman problem

param n;
set Cities := 1..n;
set Subtour within Cities;

param dist {Cities, Cities};

var X {Cities, Cities} binary;

subject to diagonal {i in Cities}: X[i,i] = 0;
subject to entering {j in Cities}: sum{i in Cities} X[i,j] = 1;
subject to leaving {i in Cities}: sum{j in Cities} X[i,j] = 1;

minimize cost: sum{i in Cities, j in Cities} X[i,j] * dist[i,j];


param no_of_cycles default 0;
set Cycle {1..no_of_cycles};

subject to excluded_cycle { k in 1..no_of_cycles }: sum{ i in Cycle[k], j in Cities diff Cycle[k] } X[i,j] >= 1;